;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;  splat-object.scm
;;;  Code for the sensed-object class and the attention scheduler
;;;  
;;;  CVS Identifier:
;;;  $Id$
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define-class <sensed-object> (<object>) 
  (state-estimate)
  (uncertainty-estimate)
  (estimator)
  (sensor-handle)
  (platform-handle))

(define (attention-scheduler-thread sched)
  (let ((best-candidate #f)
        (best-metric 0))        
    (let loop ()
      ;; iterate over the objects in the active list, determining 
      ;; which needs attention the most 
      (for-each (lambda (obj)
                  (let ((tmp-metric (attention-need-metric sched obj)))
                    (if (> tmp-metric best-metric)
                        (begin 
                          (set! best-metric tmp-metric)
                          (set! best-candidate obj)))))
                (object-list sched))
      
      ;; shift attention to that object 
      (if (not (eq? best-candidate (current-focus sched)))
          (shift-attention sched best-candidate))
      
      ;; sleep for a time between possible reschedulings 
      (if (not (break-flag sched))
          (begin 
            (thread-sleep (iteration-delay-time sched))
            (loop))))))

(define (sensed-object-thread self)
  

